# Copyright (C) 2013 Jaedyn K. Draper
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
.. module:: string_abc
	:synopsis: Provides an abstract base class to provide the same role as basestring in a python 2 and 3 compatible way
"""

from __future__ import unicode_literals, division, print_function

import abc
from . import StrType, BytesType
from .decorators import MetaClass

@MetaClass(abc.ABCMeta)
class String(object):
	"""
	Abstract base class representing both str and bytes in python3, and both unicode and str in python 2.
	"""
	pass

#pylint's not very intelligent about the @MetaClass decorator...

String.register(StrType)  # pylint: disable=no-member
String.register(BytesType)  # pylint: disable=no-member
